package jp.co.sds_corp.util.jmx.util;

import java.util.ArrayList;
import java.util.List;

import javax.management.MBeanRegistration;
import javax.management.MBeanServer;
import javax.management.ObjectName;

import jp.co.sds_corp.util.common.CmnLog;

public class Shutdown implements MBeanRegistration, ShutdownMBean
{
	public static final String OBJECT_NAME = ":type=Shutdown";
	List mbeans = new ArrayList();
	MBeanServer server;

	public void shutdown() {
		System.exit(0);
	}

	public ObjectName preRegister(final MBeanServer server, ObjectName name)
		throws java.lang.Exception
	{
		this.server = server;
		try {
			Runtime.getRuntime().addShutdownHook(new Thread() {
				public void run() {
					System.out.println("Shutting down");
					shutdownServices();
					System.out.println("Shutdown complete");
				}
			});
			CmnLog.debug( this, "Shutdown hook added");
		} catch (Throwable e) {
			CmnLog.error( this, "Could not add shutdown hook", e);
		}
		return name == null ? new ObjectName(OBJECT_NAME) : name;
	}

	public void postRegister(java.lang.Boolean registrationDone) {
	}

	public void preDeregister() throws java.lang.Exception {
	}

	public void postDeregister() {
	}

	protected void shutdownServices() {
		try {
			server.invoke(new ObjectName(":service=ServiceControl"), "stop",
							new Object[0] , new String[0]);
		} catch (Exception e) {
			CmnLog.error( this, "stop of ServiceControl failed", e);
		}

		try {
			server.invoke(new ObjectName(":service=ServiceControl"), "destroy",
							new Object[0] , new String[0]);
		} catch (Exception e) {
			CmnLog.error( this, "destroy of ServiceControl failed", e);
		}
	}
}


